//
// ȉ~
//
// written by T.Noda
//
// 2001/12/06 Ver 0.0.1 ȉ~
//
// D:a H: A:ؒfpx
//
//
//************************************
//
//  f[^ւ
//
//************************************
procedure SwapValue(var SA : double; var EA : double);
var
  temp : double;
begin
  temp := SA;
  SA := EA;
  EA := temp;
end;
//************************************
//
//  a擾
//
//************************************
function RadiusGet(px1 : double; py1 : double; px2 : double; py2 : double; px3 : double; py3 : double) : double;
var
  L1, L2, L3 : double;
begin
  L1 := Distance(px1, py1, px2, py2);
  L2 := Distance(px2, py2, px3, py3);
  L3 := Distance(px3, py3, px1, py1);
  Result := 0.5*L2/(sin(ArcCos((L1*L1+L3*L3-L2*L2)/(2.0*L1*L3))));
end;
//************************************
//
//  SW擾
//
//************************************
procedure CenterPointGet(var x0 : double; var y0 : double; x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double);
var
  a1, a2, b1, b2, xm1, ym1, xm2, ym2, ang1, ang2 : double;
  flg1, flg2 : boolean;
begin
  xm1 := 0.5*(x1+x2);  // _擾
  ym1 := 0.5*(y1+y2);
  xm2 := 0.5*(x2+x3);
  ym2 := 0.5*(y2+y3);
  ang1 := PosToAngl(x1, y1, x2, y2)+90.0;
  if ang1 > 360.0 then
  begin
    ang1 := ang1-360.0;
  end;
  ang2 := PosToAngl(x2, y2, x3, y3)+90.0;
  if ang2 > 360.0 then
  begin
    ang2 := ang2-360.0;
  end;
  if (ang1=90.0)OR(ang1=270.0) then
  begin
    x0 := xm1;
    flg1 := true;
  end
  else
  begin
    a1 := tan(ang1);
    b1 := ym1-a1*xm1;
    flg1 := false;
  end;
  if (ang2=90.0)OR(ang2=270.0) then
  begin
    x0 := xm2;
    flg2 := true;
  end
  else
  begin
    a2 := tan(ang2);
    b2 := ym2-a2*xm2;
    flg2 := false;
  end;
  if flg1 = true then
  begin
    y0 := a2*x0+b2;
  end
  else if flg2 = true then
  begin
    y0 := a1*x0+b1;
  end
  else
  begin
    x0 := -(b2-b1)/(a2-a1);
    y0 := -(a1*b2-a2*b1)/(a2-a1);
  end;
end;
//************************************
//
//  ~ʕԕ` 2001/07/19
//
//************************************
procedure PrintArc(x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double; xm : double);
var
  x0, y0, r, SA, EA : double;
begin
  r := RadiusGet(x1, y1, x2, y2, x3, y3);
  CenterPointGet(x0, y0, x1, y1, x2, y2, x3, y3);
  SA := PosToAngl(x0, y0, x1, y1);
  EA := PosToAngl(x0, y0, x3, y3);
  if EA < SA then
    begin
      SwapValue(SA, EA);
    end;
  if Abs(EA-SA) > 180.0 then
    begin
      SwapValue(SA, EA);
    end;
  AnglCheck(SA, EA);
  Arc(x0, y0, r, SA, EA);
  x0 := 2.0*xm-x0;
  SA := 540.0-SA;
  EA := 540.0-EA;
  Arc(x0, y0, r, EA, SA);
end;
//************************************
//
//  CvO
//
//************************************
Program ELLIPSE;
var
  x, y, a, b : Array of double;
  rx, ry, dx, dy, n : double;
  i : integer;

Begin

  n := 6.0; // XO̕
  SetArrayLength(x, 10);
  SetArrayLength(y, 10);
  SetArrayLength(a, 2);
  SetArrayLength(b, 2);
  Message('S_͂ĉB');
  if GetPos(x[0], y[0]) = false then
  begin
    exit.
  end;
  Message('E[_͂ĉB');
  if GetPos(x[1], y[1]) = false then
  begin
    exit.
  end;
  Message('[_͂ĉB');
  if GetPos(x[2], y[2]) = false then
  begin
    exit.
  end;

  rx := Distance(x[0], y[0], x[1], y[0]);
  ry := Distance(x[0], y[0], x[0], y[2]);
  LineType(0);  // 
  PenNo(1);     // yԍ
//  Point(x[0], y[0]); // S_
  if abs(rx-ry) < 0.0005 then
  begin
    Circle(x[0], y[0], rx);// ^~
    exit;
  end;
  x[4] := x[0];
  y[4] := y[0]+ry;
  x[5] := x[0];
  y[5] := y[0]-ry;
  y[6] := y[0];
  x[7] := x[0]+rx;
  dx := rx/n/2.0;
  dy := ry/n/2.0;
  for i:=0 to int(n*2.0) do
  begin
    x[6] := x[0]+dx*i;
    y[7] := y[4]-dy*i;
    if abs(x[6]-x[5]) > 0.0005 then
    begin
      a[0] := (y[6]-y[5])/(x[6]-x[5]);
      b[0] := (x[6]*y[5]-x[5]*y[6])/(x[6]-x[5]);
    end;
    if abs(x[7]-x[4]) > 0.0005 then
    begin
      a[1] := (y[7]-y[4])/(x[7]-x[4]);
      b[1] := (x[7]*y[4]-x[4]*y[7])/(x[7]-x[4]);
    end;
    if i = 0 then
    begin
      x[9] := x[4];
      y[9] := y[4];
      x[1] := x[9];
      y[1] := y[9];
    end
    else
    begin
      x[9] := -(b[1]-b[0])/(a[1]-a[0]);
      y[9] := -(a[0]*b[1]-a[1]*b[0])/(a[1]-a[0]);
      if (i mod 2) = 1 then
      begin
        x[2] := x[9];
        y[2] := y[9];
      end
      else
      begin
        x[3] := x[9];
        y[3] := y[9];
        PrintArc(x[3], y[3], x[2], y[2], x[1], y[1], x[0]);
        PrintArc(x[3], 2.0*y[0]-y[3], x[2], 2.0*y[0]-y[2], x[1], 2.0*y[0]-y[1], x[0]);
        x[1] := x[3];
        y[1] := y[3];
      end;
    end;
  end;
End.
